<?php

/**
** Barcode Contrast Scanner v.0.1
** "proof of concept" - Version

 * This software is open-source. License: GNUv3
 * Autor: Erich Kachel; info@erich-kachel.de; 2008
**/


function _draw_cross($image, $posarray) {
    $color=imagecolorallocate($image, 255, 255, 255);
    imagesetpixel($image, $posarray[0]-1, $posarray[1], $color);
    imagesetpixel($image, $posarray[0], $posarray[1], $color);
    imagesetpixel($image, $posarray[0]+1, $posarray[1], $color);
    imagesetpixel($image, $posarray[0], $posarray[1]-1, $color);
    imagesetpixel($image, $posarray[0], $posarray[1]+1, $color);
}

$imagefile="test_images/big_code_1.jpg";
$imagescan=imagecreatefromjpeg($imagefile);
$image=imagecreatefromjpeg($imagefile);
imagefilter($image, IMG_FILTER_GRAYSCALE);
imagefilter($imagescan, IMG_FILTER_GRAYSCALE);

$imagesize=getimagesize($imagefile);
$w=$imagesize[0];
$h=$imagesize[1];


$scanline = imagecreatetruecolor($w, $h);

$start_sequence = array('lsl');

$ean_data = array('3211'=>'0',
                  '1123'=>'0',
                  '2221'=>'1',
                  '1222'=>'1',
                  '2122'=>'2',
                  '2212'=>'2',
                  '1411'=>'3',
                  '1141'=>'3',
                  '1132'=>'4',
                  '2311'=>'4',
                  '1231'=>'5',
                  '1321'=>'5',
                  '1114'=>'6',
                  '4111'=>'6',
                  '1312'=>'7',
                  '2131'=>'7',
                  '1213'=>'8',
                  '3121'=>'8',
                  '3112'=>'9',
                  '2113'=>'9',
                  );

$steps = 2;

$stepdiff = floor($h / $steps);

$y = ceil($h / $steps) - 20;

$contrast = $_GET['c'];

for ($ww=0; $ww < $steps-1; $ww++) {
    $r_min = 255;
    $r_max = 0;

    // calculate here the position of scanning line - for each possible step
    $y = $stepdiff;

    $scanrow++;
    $begin_flag = false;
    $data = array();
    echo "<br>";
    for ($x=0; $x<$w; $x=$x+1) {

            $colorindex=imagecolorat($imagescan, $x, $y);
            list($r1,$g,$b) = array_values(imagecolorsforindex($imagescan, $colorindex));
            $colorindex=imagecolorat($imagescan, $x, $y-1);
            list($r2,$g,$b) = array_values(imagecolorsforindex($imagescan, $colorindex));
            $colorindex=imagecolorat($imagescan, $x, $y+1);
            list($r3,$g,$b) = array_values(imagecolorsforindex($imagescan, $colorindex));

            // calculate arithmetic mean from gray scale below and beneath the scanned point
            $r = ($r1 + $r2 + $r3) / 3;
            $r = $r1;
/**/
            if ($r_min - $r >= $contrast) {
                $r_min_pos = array($x, $y);
                _draw_cross($image, $r_min_pos);
                $black_start = $r_min_pos;
                $black_flag = true;

                // line starts here
                if ($white_flag && $black_flag) {
                    $white_flag = false;
                    //echo "|$space_thickness|";
                    $spaces[] = array('thickness'=>$space_thickness, 'counter'=>1);
                    $data[] = $space_thickness;
                    $space_thickness = 0;
                }
            }
            if ($r - $r_max >= $contrast) {
                $r_max_pos = array($x, $y);
                _draw_cross($image, $r_max_pos);
                $black_end = $r_max_pos;
                $white_flag = true;

                // line ends here
                if ($white_flag && $black_flag) {
                    $black_flag = false;
                    //echo "#$line_thickness#";

                    $lines[] = array('thickness'=>$line_thickness, 'counter'=>1);

                    // was an empty space before? then it is the begin
                    if (!$begin_flag) {
                        // if spaces before and more than 7 times longer, then begin
                        if (count($spaces) > 0) {
                            if ($line_thickness * 5 < $spaces[count($spaces)-1]['thickness']) {
                                // obviously the beginning
                                $begin_flag = true;
                                // remove previous data
                                $data = array();
                                echo "!!!";
                                _draw_cross($image, $r_max_pos);
                            }
                        } else {

                        }
                    }
                    // intentionally put here, after we decide if it is the start of sequence
                    $data[] = $line_thickness;
                    $line_thickness = 0;
                }

            }

            // line is in progress
            if ($black_flag && !$white_flag) {
                $line_thickness++;
            }
            // space is in progress
            if ($white_flag && !$black_flag) {
                $space_thickness++;
            }

            $r_min = $r;
            $r_max = $r;
            //echo ($r_mem) . "-";
            //echo $r;
            //_draw_cross($image, array($x, $y));
/**/

    }
    $single_line_width = array();
    $single_space_width = array();

    if (count($data) > 3) {

        //first three elements
        $single_line_width[] = $data[0];
        $single_line_width[] = $data[2];
        $single_space_width[] = $data[1];

        for($m=0; $m < count($data); $m++) {
            if ($m % 2) {
                // space
                echo '<font color="red">';
            }
            echo "$data[$m]|";
            if ($m % 2) {
                echo '</font>';
            }
        }
        echo "<br>";

        for($m=3; $m < count($data); $m++) {

            // find best matching value
            if ($m % 2) {
                // space
                $lowest = 1;
                for($i=0; $i < count($single_space_width); $i++) {
                    $divisor = $single_space_width[$i];
                    $divide_master = ($data[$m] / $single_space_width[$i]);
                    $divide_diff = $divide_master - round($divide_master);
                    if ($divide_diff < 0) {
                        $divide_diff = $divide_diff * -1;
                    }
                    if ($lowest > $divide_diff) {
                        $lowest = $divide_diff;
                        if ($divide_diff > 0.3) {
                            $single_data = ceil($divide_master);
                        } else {
                            $single_data = floor($divide_master);
                        }
                    }
                }

                if ($single_data > 0) {
                    $single_space_width[] = round($data[$m] / $single_data);
                }

            } else {
                // line
                //echo "L";
                $lowest = 1;
                for($i=0; $i < count($single_line_width); $i++) {
                    if ($single_line_width[$i] == 0) {
                        $divide_master = 0;
                    } else {
                        $divide_master = ($data[$m] / $single_line_width[$i]);
                    }
                    $divide_diff = $divide_master - round($divide_master);
                    if ($divide_diff < 0) {
                        $divide_diff = $divide_diff * -1;
                    }
                    if ($lowest >= $divide_diff) {
                        $lowest = $divide_diff;
                        if ($divide_diff > 0.1) { // adjust less, because lines are more thin and precise
                            $single_data = ceil($divide_master);
                        } else {
                            $single_data = floor($divide_master);
                        }
                    }
                }
                echo $data[$m] . "/" . $divisor . ":" . $divide_master . ":" . $single_data . "#";
                if ($single_data > 0) {
                    $single_line_width[] = round($data[$m] / $single_data);
                }
            }

            $divide = $single_data;
            //echo $divide_master . ":" . $divide . "#";
            if ($divide > 4) {
                $decoded_data[] = array('decoded'=>4, 'precision'=>$divide_master);

            } else {
                $decoded_data[] = array('decoded'=>$divide, 'precision'=>$divide_master);
            }
        }
        echo "<br>";
        $decoded_ean = array(4);

        $process = true;
        $startposition = 0;
        while($startposition < count($decoded_data)) {
            $data_block = '';
            for ($t=$startposition; $t <= $startposition+3; $t++) {
                $data_block .= $decoded_data[$t]['decoded'];
            }

            // middle separator
            if ($data_block == '1111') {
                $startposition = $startposition + 5;
            } else {
                $startposition = $startposition + 4;
            }
            if (isset($ean_data[$data_block])) {
                echo $data_block . ":";
                echo "(" . $ean_data[$data_block] . ")";
                $decoded_ean[] = $ean_data[$data_block];
            } else {
                // no match
                // try to find another code if you decrease the highest positions
                $new_data_block = '';
                for($g=0; $g < strlen($data_block); $g++) {
                    if ($data_block[$g] > 2) {
                        $new_data_block .= $data_block[$g] - 1;
                    } else {
                        $new_data_block .= $data_block[$g];
                    }
                }

                if (isset($ean_data[$new_data_block])) {
                    echo $data_block . "~" . $new_data_block . ":";
                    echo "(" . $ean_data[$new_data_block] . ")";
                    $decoded_ean[] = $ean_data[$new_data_block];
                }

                // try to find another code if you increase the highest positions
                $new_data_block = '';
                for($g=0; $g < strlen($data_block); $g++) {
                    if ($data_block[$g] > 2) {
                        $new_data_block .= $data_block[$g] + 1;
                    } else {
                        $new_data_block .= $data_block[$g];
                    }
                }

                if (isset($ean_data[$new_data_block])) {
                    echo $data_block . "~" . $new_data_block . ":";
                    echo "(" . $ean_data[$new_data_block] . ")";
                    $decoded_ean[] = $ean_data[$new_data_block];
                }
            }
        }
    }
/*
    echo "<br>";
    $sum = 0;
    $switch31 = true;
    for($m=count($decoded_ean)-2; $m >= 0; $m--) {
        echo $decoded_ean[$m];
        if ($switch31) {
            $sum += ($decoded_ean[$m] * 3);
            $switch31 = false;
        } else {
            $sum += ($decoded_ean[$m] * 1);
            $switch31 = true;
        }
    }

    if (($sum + $decoded_ean[count($decoded_ean)-1]) % 10 == 0) {
        echo "EAN ok";
    }  else {
        echo "EAN failure";
    }
 */
}

for($m=0; $m < count($diffmatrix); $m++) {
    //_draw_cross($image, array($diffmatrix[$m]['x'], $diffmatrix[$m]['y']));
}

echo "<br>";
//$image = imagerotate($image, -18, 0);

imagejpeg($image,'out.jpeg');

echo '<img src="out.jpeg">';
?>
<form action="" method="get">
    a:<input type="text" name="a" value="<?php echo $_GET['a']; ?>"> a-bis:<input type="text" name="abis" value="<?php echo $_GET['abis']; ?>"><br>
    b:<input type="text" name="b" value="<?php echo $_GET['b']; ?>"> b-bis:<input type="text" name="bbis" value="<?php echo $_GET['bbis']; ?>"><br>
    contrast:<input type="text" name="c" value="<?php echo $_GET['c']; ?>"><br>
    <input type="submit" name="submit" value="go">
</form>
